package mirror

import (
	"archive/tar"
	"bufio"
	"bytes"
	"context"
	"encoding/json"
	"errors"
	"fmt"
	"io"
	"log/slog"
	"os"
	"path"

	"github.com/opencontainers/go-digest"
	ocispec "github.com/opencontainers/image-spec/specs-go/v1"
	"oras.land/oras-go/v2"
	"oras.land/oras-go/v2/content"
	"oras.land/oras-go/v2/content/memory"
	"oras.land/oras-go/v2/errdef"
	"oras.land/oras-go/v2/registry"

	"gitlab.com/act3-ai/asce/data/tool/internal/mirror/encoding"
	"gitlab.com/act3-ai/asce/data/tool/internal/orasutil"
	"gitlab.com/act3-ai/asce/data/tool/internal/print"
	"gitlab.com/act3-ai/asce/data/tool/internal/ui"
	"gitlab.com/act3-ai/asce/go-common/pkg/ioutil"
	"gitlab.com/act3-ai/asce/go-common/pkg/logger"
)

// DeserializeOptions specify the requirements to run the mirror deserialize command.
type DeserializeOptions struct {
	DestTarget          oras.Target
	DestTargetReference registry.Reference
	SourceFile          string
	BufferSize          int
	DryRun              bool
	RootUI              *ui.Task
	Strict              bool
	Log                 *slog.Logger
}

// Deserialize will extract the oci artifacts from a tar file (generated by ace-dt mirror serialize) to a destination target.
func Deserialize(ctx context.Context, opts DeserializeOptions) error { //nolint:gocognit
	tag := opts.DestTargetReference.ReferenceOrDefault()

	// open input file for reading
	src, err := os.Open(opts.SourceFile)
	if err != nil {
		return fmt.Errorf("error opening the source file provided: %w", err)
	}
	defer src.Close()

	var sr io.Reader = src
	if opts.BufferSize != 0 {
		sr = bufio.NewReaderSize(src, opts.BufferSize)
	}
	cw := new(ioutil.WriterCounter)
	tr := tar.NewReader(io.TeeReader(sr, cw))

	storage := opts.DestTarget

	// add to the remote existence cache (optimization)
	storage = orasutil.NewExistenceCachedTarget(storage)

	// Disable Push() and Tag()
	if opts.DryRun {
		storage = orasutil.NewNoPushTarget(storage)
	}

	var cache content.Storage = memory.New()

	tracker := encoding.NewTaggableTracker(storage, cache)
	tracker.FindSuccessors = encoding.Successors

	type stage int
	const (
		stageUndefined stage = iota
		stageOCILayout
		stageIndexJSON
		stageBlob
	)
	currentStage := stageOCILayout
	var indexDesc *ocispec.Descriptor

	task := opts.RootUI.SubTask("Deserializing")
	defer task.Complete()

	// consume the tar data
	for {
		hdr, err := tr.Next()
		if errors.Is(err, io.EOF) {
			break
		}
		if err != nil {
			return fmt.Errorf("error getting tar header: %w", err)
		}

		// skip all directories
		if hdr.FileInfo().IsDir() {
			continue
		}

		fname := hdr.Name
		if !opts.Strict {
			fname = path.Clean(fname)
		}

		task.Info(hdr.Name)
		log := opts.Log.With("filename", fname, "size", hdr.Size)
		log.DebugContext(ctx, "Current stage", "stage", currentStage)

		switch {
		case fname == ocispec.ImageLayoutFile:
			if err := consumeOCILayout(tr); err != nil {
				return err
			}
			if opts.Strict {
				// oci-layout is expected first
				if currentStage != stageOCILayout {
					return fmt.Errorf("expected the first file to be named %q", ocispec.ImageLayoutFile)
				}
				currentStage++
			}

		case fname == ocispec.ImageIndexFile:
			if indexDesc != nil {
				// silently ignore extra index.json files
				continue
			}

			catalog, err := consumeIndexJSON(tr)
			if err != nil {
				return err
			}

			// filter on ocispec.AnnotationRefName
			var desc *ocispec.Descriptor
			for i, d := range catalog.Manifests {
				if _, ok := d.Annotations[ocispec.AnnotationRefName]; ok {
					if desc != nil {
						// multiple name references
						// ambiguous index.json
						return fmt.Errorf("expected one manifest in %q with %q set but found a second at %d", ocispec.ImageIndexFile, ocispec.AnnotationRefName, i)
					}
					desc = &catalog.Manifests[0]
				}

				// start by tracking the index manifest
				if err := tracker.NotifyManifest(ctx, d); err != nil {
					return err
				}
			}

			// if we only have one just use it
			if len(catalog.Manifests) == 1 {
				desc = &catalog.Manifests[0]
			}

			if desc == nil {
				return fmt.Errorf("multiple manifests in index.json, but no manifest with %s was set", ocispec.AnnotationRefName)
			}

			if opts.Strict {
				// second we expect the index.json file
				if currentStage != stageIndexJSON {
					return fmt.Errorf("expected the second file to be named %q", ocispec.ImageIndexFile)
				}
				currentStage++
			}
			indexDesc = desc

		case path.Dir(path.Dir(fname)) == "blobs":
			if err := consumeBlob(ctx, fname, hdr.Size, tr, tracker, storage, cache); err != nil {
				return err
			}
			if opts.Strict {
				if currentStage != stageBlob {
					return fmt.Errorf("expected the third file onward to be a blob")
				}
				// stay in blobs stage forever
				// TODO verify that the ordering is depth-first.  Meaning that we always see the necessary manifests before the blobs for the manifest.
			}

		default:
			if opts.Strict {
				return fmt.Errorf("unexpected file %q", hdr.Name)
			}
			log.InfoContext(ctx, "Ignoring file", "name", hdr.Name)
		}
		opts.RootUI.Infof("read %s", print.Bytes(int64(*cw)))
	}

	if indexDesc == nil {
		return fmt.Errorf("missing %q file", ocispec.ImageIndexFile)
	}

	if missing := tracker.MissingBlobs(); len(missing) != 0 {
		// log the missing blobs from all manifests
		opts.Log.InfoContext(ctx, "Missing blobs", "missing", missing)
		return fmt.Errorf("%d missing blobs", len(missing))
	}

	// Tag it based on the input from the user
	opts.RootUI.Infof("Tagging root node as %q", tag)
	if err := storage.Tag(ctx, *indexDesc, tag); err != nil {
		return fmt.Errorf("pushing the %q file: %w", ocispec.ImageIndexFile, err)
	}

	opts.RootUI.Infof("Digest: %s", indexDesc.Digest)

	return src.Close()
}

func consumeOCILayout(r io.Reader) error {
	// use oci-layout file as a sanity check and error if it is not right
	// does not get sent to the registry or processed further (yet)
	// future systems might need the version for backwards compatibility.
	var layout ocispec.ImageLayout
	if err := json.NewDecoder(r).Decode(&layout); err != nil {
		return fmt.Errorf("error unmarshalling OCI Layout file: %w", err)
	}
	if layout.Version != ocispec.ImageLayoutVersion {
		return fmt.Errorf("error improper imageLayoutVersion: %s", layout.Version)
	}

	return nil
}

func consumeIndexJSON(r io.Reader) (*ocispec.Index, error) {
	raw, err := io.ReadAll(r)
	if err != nil {
		return nil, fmt.Errorf("reading %s: %w", ocispec.ImageIndexFile, err)
	}

	index := &ocispec.Index{}
	if err := json.Unmarshal(raw, index); err != nil {
		return nil, err
	}

	return index, nil
}

func consumeBlob(ctx context.Context,
	fname string, size int64, r io.Reader,
	tracker *encoding.TaggableTracker,
	remoteStorage, cache content.Storage,
) error {
	log := logger.FromContext(ctx)

	// extract the digest from the filename
	// This is the algorithm+digest that at will be used to refer to this blob.
	// We support other algorithms points to the same blob by way of having a different file in the blobs folder.
	// We can use hard link or symbolic links in the tar archive to de-duplicate data that is the same (but different digest algorithms)
	h := digest.NewDigestFromHex(path.Base(path.Dir(fname)), path.Base(fname))

	log.With("digest", h)

	blobDesc := ocispec.Descriptor{
		MediaType: "application/octet-stream",
		Digest:    h,
		Size:      size,
	}

	// check to see if the registry already has this blob
	exists, err := remoteStorage.Exists(ctx, blobDesc)
	if err != nil {
		return fmt.Errorf("checking existence of a blob: %w", err)
	}

	if manDesc := tracker.KnownTaggable(h); manDesc != nil {
		// TODO condition this on a maximum size (but that would fail to work on JFrog Artifactory)

		data, err := content.ReadAll(r, *manDesc)
		if err != nil {
			return fmt.Errorf("reading data to populate the cache: %w", err)
		}

		// optimization (required for JFrog Artifactory)
		err = cache.Push(ctx, *manDesc, bytes.NewReader(data))
		switch {
		case errors.Is(err, errdef.ErrAlreadyExists):
		case err != nil:
			return fmt.Errorf("populating cache with manifest: %w", err)
		}

		// While we might have a descriptor for a manifest.  Technically it could be a blob as well.
		// So we upload the manifest data as a blob
		r = bytes.NewReader(data)
	}

	if !exists {
		log.InfoContext(ctx, "Transferring blob", "name", fname)
		if err := remoteStorage.Push(ctx, blobDesc, r); err != nil {
			return fmt.Errorf("pushing blob: %w", err)
		}
	}

	// Now that the blobs are all handled properly.
	// now the hard part...
	// Figure out which manifests are free to be sent to the registry (when all their dependents (manifests and blobs) are present)

	return tracker.AddBlob(ctx, h)
}
